未加星标

Require.js + SignalR

字体大小 | |
[前端(javascript) 所属分类 前端(javascript) | 发布者 店小二03 | 时间 2019 | 作者 红领巾 ] 0人收藏点击收藏

I have been working with Require.JS and SignalR over the past few days and I noticed that when I load my site sometimes the SignalR/Hubs seems to get loaded before jquery despite my require.js configuration appearing to be correct.

Here's my config:

require.config({ paths: { jQuery: 'libs/jquery/jquery', Underscore: 'libs/underscore/underscore', Backbone: 'libs/backbone/backbone', Marionette: 'libs/backbone/backbone.marionette' } }); require([ 'app', 'order!libs/jquery/jquery-min', 'order!libs/jQueryUI/jquery-ui-1.8.11.min', 'order!libs/jqGrid/grid.locale-en', 'order!libs/jqGrid/jquery.jqGrid.min', 'order!libs/underscore/underscore-min', 'order!libs/backbone/backbone-min', 'order!Marionette', 'order!libs/jquery.signalR-0.5.1', 'order!noext!signalr/hubs' ], function (app) { app.initialize(); });

When this fails I get an error on line 16 of the hubs file. It says uncaught TypeError: Cannot read property 'signalR' of undefined .

Upgraded to V2 and modified my config.

var fRequire = require.config({ paths: { jQuery: 'libs/jquery/jquery', Underscore: 'libs/underscore/underscore', Backbone: 'libs/backbone/backbone', Marionette: 'libs/backbone/backbone.marionette', sigr: 'libs/jquery.signalR-0.5.1' }, shims: { "libs/jquery.signalR-0.5.1": { deps: ["jQuery"] }, "libs/jqGrid/jquery.jqGrid.min": { deps: ["jQuery"] }, "libs/jquery/jquery-ui-1.8.19.min": { deps: ["jQuery"] }, "libs/jqGrid/grid.locale-en": { deps: ["jQuery"] }, "noext!signalr/hubs": { deps: ["sigr"] } } }); fRequire([ 'app' ], function (app) { app.initialize(); });

Now require is looking in the wrong locations for jquery, underscore, etc...despite my telling it specifically where to look. Perhaps this has something to do with me following an old tutorial when I configured require using v1.

http://backbonetutorials.com/organizing-backbone-using-modules/

FINAL UPDATE:

Here is my working config. Hopefully it'll help any newbies like myself get passed this issue.

require.config({ baseUrl: '/js', paths: { "jquery": 'libs/jquery/jquery-min', "underscore": 'libs/underscore/underscore-min', "backbone": 'libs/backbone/backbone-min', "marionette": 'libs/backbone/backbone.marionette', "sigr": 'libs/jquery.signalR-0.5.1' }, shims: { "backbone": { deps: ["underscore", "jquery"], exports: "Backbone" }, "underscore": { deps: ["jquery"] }, "marionette": { deps: ["backbone", "jquery"] }, "sigr": { deps: ["jquery"] }, "libs/jqGrid/jquery.jqGrid.min": { deps: ["jquery"] }, "libs/jquery/jquery-ui-1.8.19.min": { deps: ["jquery"] }, "libs/jqGrid/grid.locale-en": { deps: ["jquery"] }, "noext!signalr/hubs": { deps: ["sigr"] } } }); // for future ref, I loaded jquery here because app.js references sigr which requires it. // without enabling it before the module is loaded sigr would complain jquery was not enabled. require([ 'libs/domReady', 'app', 'jquery' ], function (domReady, app, $) { domReady(function () { app.initialize(); }); });

It was mandatory that I load jquery in the function(domready, app, $). Failing to do so will result in signalr reporting that it cannot be found.

If you're using requirejs 2.x you can use the "shims" config attribute. There you can specify the dependencies between files that are not AMD compliant, like jquery, jqueryui, etc..

Using your configuration as example:

require.config({ paths: { jQuery: 'libs/jquery/jquery', Underscore: 'libs/underscore/underscore', Backbone: 'libs/backbone/backbone', Marionette: 'libs/backbone/backbone.marionette' }, // specify depedencies shim: { "libs/jquery.signalR-0.5.1" : { deps: ["jQuery"] }, "libs/jqGrid/jquery.jqGrid.min" : { deps: ["jQuery"] } } });

Also, configure the dependencies in "shims" eliminates the use of the "order!" plugin.

Tip:Use "paths" to set a friendly name for apis that your system use, so when a new version of that api is released you can just change in "paths" and you're done.

本文前端(javascript)相关术语:javascript是什么意思 javascript下载 javascript权威指南 javascript基础教程 javascript 正则表达式 javascript设计模式 javascript高级程序设计 精通javascript javascript教程

代码区博客精选文章
分页:12
转载请注明
本文标题:Require.js + SignalR
本站链接:https://www.codesec.net/view/628317.html


1.凡CodeSecTeam转载的文章,均出自其它媒体或其他官网介绍,目的在于传递更多的信息,并不代表本站赞同其观点和其真实性负责;
2.转载的文章仅代表原创作者观点,与本站无关。其原创性以及文中陈述文字和内容未经本站证实,本站对该文以及其中全部或者部分内容、文字的真实性、完整性、及时性,不作出任何保证或承若;
3.如本站转载稿涉及版权等问题,请作者及时联系本站,我们会及时处理。
登录后可拥有收藏文章、关注作者等权限...
技术大类 技术大类 | 前端(javascript) | 评论(0) | 阅读(27)